### Status

**Status info updated 7/7/2011**

Tarn is still an early-stage (pre-alpha) project.

Tarn 0.1.10 is [available on PyPi](http://pypi.python.org/pypi/tarn/0.1.10) and can be installed with standard tools like `pip`, etc.

I'm using Tarn to test the App Engine website for my new personal security service, [Cloak](https://www.getcloak.com/). Tarn provides a ton of useful `TestCase`-derived classes that help you quickly set up and tear down data store, mail, task queue, etc. tests on App Engine -- I use pretty much all of these base classes in the unit and integration tests for [Cloak](https://www.getcloak.com/)

I believe that Tarn is strong enough to be a replacement for your App Engine testing already, but you'll have to take on the pain of learning how to use it by looking at the code. In the future, after Tarn matures, I will have fuller documentation available here...


###Tarn: Test Appengine Right Now!

`Tarn` is a new test runner and framework for [Google App Engine](http://code.google.com/appengine/) python developers. It requires App Engine SDK 1.4.3 or above.

You can run tests either by invoking the `tarn` command line, which is simply a wrapper around `unittest2`, or you can use the `--with-tarn` hook to invoke the tarn `nosetests` plugin. Either way, you get `tarn` goodness.

The framework provides several `unittest2.TestCase`-derived base classes to simplify the work of writing solid unit and integration tests. Under the hood, these base classes make use of the new `testbed` APIs that were released with App Engine SDK 1.4.3. The inspiration for these tests comes from the old `gaetestbed` library by JJ Geewax, parts of which are now part of the official Python SDK. Other parts of `gaetestbed` didn't make it in to the SDK, so we're helping here. The `WebTestCase` base class further depends on Ian Bicking's `webtest` module, though this dependency will probably ultimately be removed in favor of a simpler custom WSGI invoker.


###Installing `tarn`

You can install `tarn` from the Python Package Index via `pip install tarn` or `easy_install tarn`, or by cloning this repository.

To run directly from this repository, use `XXX`.

To package up a submission to PyPi, use `python setup.py register sdist bdist_wininst upload`.


###Using the test runner

To run your test cases, simply invoke `tarn` from your application's root directory (aka the directory with `app.yaml`)

TODO: document all the command line options, ability to run only some tests, etc.


###Using the framework

TODO: document this. Right now, the code is the best documentation.


###License

Because portions of this framework are based on JJ Geewax's gaetestbed, the entire Tarn package is distributed under GPLv2. See `COPYING.txt`.



