from distutils.core import setup

setup(
    name = 'tarn',
    version = '0.1.13',
    author = 'Dave Peck',
    author_email = 'davepeck+tarn@gmail.com',
    url = 'http://github.com/davepeck/tarn/',
    description = 'A modern App Engine test runner and framework.',
    license = 'MIT',
    keywords = 'test unittest appengine automatic discovery',
    long_description = """\
TARN: Test Appengine Right Now!

Tarn is a modern App Engine test runner and framework.

It's modern in that:

1. It offers both a unittest2-based command line runner and a nose plugin
2. It uses the new testbed APIs that shipped with App Engine SDK 1.4.3
3. It provides several nice unittest2-derived base classes, deeply inspired by JJ Geewax's work on now defunct gaetestbed

Pre-alpha; no real documentation is available yet -- but I'll get to it soon!
""",
    packages = ["tarn", "tarn.case"],
    classifiers = [
        'Development Status :: 2 - Pre-Alpha',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: GNU General Public License (GPL)',
        'Natural Language :: English',
        'Operating System :: OS Independent',
        'Programming Language :: Python',
        'Topic :: Software Development :: Testing',
    ],
    scripts = ["bin/tarn"],
    install_requires = ["WebTest >= 1.2.3", "unittest2 >= 0.5.1", "dingus >= 0.3.2"],
    entry_points = {'nose.plugins': ['tarn = tarn.noseplugin:TarnPlugin']},
)
