from __future__ import absolute_import # Python 2.5+
import sys
import unittest2


class BaseTestCase(unittest2.TestCase):
    """A few helpful methods that all test cases will need."""
    
    def setUp(self):
        super(BaseTestCase, self).setUp()        
    
    def get_length(self, iterable):
        length = None

        if length is None:
            try: 
                length = iterable.count()
            except: 
                pass

        if length is None:
            try: 
                length = len(iterable)
            except: 
                pass
            
        if length is None:
            self.fail("Unable to get length for object %s" % type(iterable))
        
        return length
        
    def assertLength(self, iterable, count):
        self.assertEqual(self.get_length(iterable), count)
            
    def assertLengthNotEqual(self, iterable, count):
        self.assertNotEqual(self.get_length(iterable), count)
        
    def assertHasItems(self, iterable):
        self.assertTrue(self.get_length(iterable) > 0)
    
    def assertEmpty(self, iterable):
        self.assertTrue(self.get_length(iterable) == 0)
        
