from __future__ import absolute_import # Python 2.5+
import unittest2
from google.appengine.ext import testbed
from google.appengine.api import memcache
from tarn.case.testbed import TestbedTestCase


class MemcacheTestCase(TestbedTestCase):
    def setUp(self):
        super(MemcacheTestCase, self).setUp()
        self.testbed.init_memcache_stub()
        self.clear_memcache()
    
    def clear_memcache(self):
        memcache.flush_all()
        
    def assertMemcacheHitCount(self, hits):
        self.assertEqual(memcache.get_stats().get('hits', None), hits)
    
    def assertMemcacheItemCount(self, items):
        self.assertEqual(memcache.get_stats().get('items', None), items)
        
    def assertKeyInMemcache(self, key, namespace = None):
        self.assertTrue(memcache.get(key, namespace = namespace) is not None)
    
    def assertKeyNotInMemcache(self, key, namespace = None):
        self.assertTrue(memcache.get(key, namespace = namespace) is None)


        
    
        