from __future__ import absolute_import # Python 2.5+
import unittest2
from google.appengine.ext import testbed
from tarn.case.base import BaseTestCase


class TestbedTestCase(BaseTestCase):
    def __init__(self, *args, **kwargs):
        super(TestbedTestCase, self).__init__(*args, **kwargs)
        self._testbed = None
    
    def setUp(self):
        super(TestbedTestCase, self).setUp()
        assert (self._testbed is None)
        self._testbed = testbed.Testbed()
        self._testbed.activate()
    
    def tearDown(self):
        assert (self._testbed is not None)
        self._testbed.deactivate()
        self._testbed = None
        super(TestbedTestCase, self).tearDown()
        
    @property
    def testbed(self):
        return self._testbed
